/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
	"fmt"
)

// JumpTarget the model 'JumpTarget'
type JumpTarget string

// List of JumpTarget
const (
	JumpTargetExit JumpTarget = "exit"
	JumpTargetNext JumpTarget = "next"
	JumpTargetBlock JumpTarget = "block"
	JumpTargetNowhere JumpTarget = "no"
)

// All allowed values of JumpTarget enum
var AllowedJumpTargetEnumValues = []JumpTarget{
	"exit",
	"next",
	"block",
	"no",
}

func (v *JumpTarget) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := JumpTarget(value)
	for _, existing := range AllowedJumpTargetEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid JumpTarget", value)
}

// NewJumpTargetFromValue returns a pointer to a valid JumpTarget
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewJumpTargetFromValue(v string) (*JumpTarget, error) {
	ev := JumpTarget(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for JumpTarget: valid values are %v", v, AllowedJumpTargetEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v JumpTarget) IsValid() bool {
	for _, existing := range AllowedJumpTargetEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to JumpTarget value
func (v JumpTarget) Ptr() *JumpTarget {
	return &v
}

type NullableJumpTarget struct {
	value *JumpTarget
	isSet bool
}

func (v NullableJumpTarget) Get() *JumpTarget {
	return v.value
}

func (v *NullableJumpTarget) Set(val *JumpTarget) {
	v.value = val
	v.isSet = true
}

func (v NullableJumpTarget) IsSet() bool {
	return v.isSet
}

func (v *NullableJumpTarget) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableJumpTarget(val *JumpTarget) *NullableJumpTarget {
	return &NullableJumpTarget{value: val, isSet: true}
}

func (v NullableJumpTarget) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableJumpTarget) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

